package com.hai.config;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hai.common.pay.util.MD5Util;
import com.hai.common.security.DesUtil;
import com.hai.common.utils.HttpsUtils;

import org.apache.commons.collections4.MapUtils;

import java.nio.charset.Charset;
import java.util.*;

/**
 * 汇联通会员卡业务接口
 */
public class HuiLianTongUnionCardConfig {

    /**
     * 获取token
     * @return
     * @throws Exception
     */
    public static JSONObject queryCardByMobile() throws Exception {
        // 签名码
        String signCode = "F8E91A3C";

        Map<String,Object> map = new LinkedHashMap<>();
        map.put("accessCode", "6FCAE1470CEF465988351BB65ABAA8AE");
        map.put("requestId", new Date().getTime());
        map.put("method", "qgk/queryCardByMobile");

        // 业务数据
        Map<String,Object> dataMap = new HashMap<>();
        dataMap.put("userMobile", "15185028745");

        // 转换成json
        String dataJson = JSONObject.toJSONString(dataMap);
        System.out.println(dataJson);

        // DES加密
        map.put("data", DesUtil.encode(dataJson, Charset.forName("UTF-8"),signCode));
        System.out.println(MapUtils.getString(map,"data"));

        // 数据签名字符串
        String str = (MapUtils.getString(map,"accessCode")+signCode);
               str +=(MapUtils.getString(map,"requestId")+signCode) ;
               str += (MapUtils.getString(map,"method") + signCode);
               str += (MapUtils.getString(map,"data") + signCode);
        System.out.println(str);

        // MD5加密
        map.put("sign", MD5Util.MD5Encode(str, "UTF-8").toUpperCase());
        System.out.println(MapUtils.getString(map, "sign"));
        return HttpsUtils.doPost("http://hltgz.com:4010/api/v2/execute.json", JSON.toJSONString(map));
    }

    /**
     * 获取token
     * @return
     * @throws Exception
     */
    public static JSONObject queryBalance() throws Exception {
        // 签名码
        String signCode = "F8E91A3C";

        Map<String,Object> map = new LinkedHashMap<>();
        map.put("accessCode", "6FCAE1470CEF465988351BB65ABAA8AE");
        map.put("requestId", new Date().getTime());
        map.put("method", "qtk/queryBalance");

        // 业务数据
        Map<String,Object> dataMap = new HashMap<>();
        dataMap.put("cardType", "ghk");
        dataMap.put("cardNo", "8800030115015107746");

        // 转换成json
        String dataJson = JSONObject.toJSONString(dataMap);
        System.out.println(dataJson);

        // DES加密
        map.put("data", DesUtil.encode(dataJson, Charset.forName("UTF-8"),signCode));
        System.out.println(MapUtils.getString(map,"data"));

        // 数据签名字符串
        String str = (MapUtils.getString(map,"accessCode")+signCode);
        str +=(MapUtils.getString(map,"requestId")+signCode) ;
        str += (MapUtils.getString(map,"method") + signCode);
        str += (MapUtils.getString(map,"data") + signCode);
        System.out.println(str);

        // MD5加密
        map.put("sign", MD5Util.MD5Encode(str, "UTF-8").toUpperCase());
        System.out.println(MapUtils.getString(map, "sign"));
        return HttpsUtils.doPost("http://hltgz.com:4010/api/v2/execute.json", JSON.toJSONString(map));
        //  return null;
    }

    /**
     * 获取token
     * @return
     * @throws Exception
     */
    public static JSONObject queryCardInfo() throws Exception {
        // 签名码
        String signCode = "F8E91A3C";

        Map<String,Object> map = new LinkedHashMap<>();
        map.put("accessCode", "6FCAE1470CEF465988351BB65ABAA8AE");
        map.put("requestId", new Date().getTime());
        map.put("method", "qgk/queryCardInfo");

        // 业务数据
        Map<String,Object> dataMap = new HashMap<>();
        dataMap.put("cardNo", "8800030115015107746");

        // 转换成json
        String dataJson = JSONObject.toJSONString(dataMap);
        System.out.println(dataJson);

        // DES加密
        map.put("data", DesUtil.encode(dataJson, Charset.forName("UTF-8"),signCode));
        System.out.println(MapUtils.getString(map,"data"));

        // 数据签名字符串
        String str = (MapUtils.getString(map,"accessCode")+signCode);
        str +=(MapUtils.getString(map,"requestId")+signCode) ;
        str += (MapUtils.getString(map,"method") + signCode);
        str += (MapUtils.getString(map,"data") + signCode);
        System.out.println(str);

        // MD5加密
        map.put("sign", MD5Util.MD5Encode(str, "UTF-8").toUpperCase());
        System.out.println(MapUtils.getString(map, "sign"));
        return HttpsUtils.doPost("http://hltgz.com:4010/api/v2/execute.json", JSON.toJSONString(map));
        //  return null;
    }




}
